unit Unit4;

interface

uses
  Classes, IWAppForm, IWCompListbox, IWCompButton,
  IWCompEdit, IWCompLabel, Controls, IWVCLBaseControl, IWBaseControl,
  IWBaseHTMLControl, IWControl, IWHTML5LocalStorage;
type
  TIWForm4 = class(TIWAppForm)
    TIWHTML5LocalStorage1: TTIWHTML5LocalStorage;
    labelName: TIWLabel;
    editName: TIWEdit;
    labelFirstName: TIWLabel;
    editFirstName: TIWEdit;
    editStreet: TIWEdit;
    labelStreet: TIWLabel;
    editCity: TIWEdit;
    labelCity: TIWLabel;
    editZip: TIWEdit;
    labelZip: TIWLabel;
    labelCountry: TIWLabel;
    editCountry: TIWEdit;
    btSave: TIWButton;
    btLoad: TIWButton;
    btClear: TIWButton;
    IWListbox1: TIWListbox;
    btShowAll: TIWButton;
    IWLabel5: TIWLabel;
    IWButton1: TIWButton;
    IWLabel1: TIWLabel;
    IWLabel2: TIWLabel;
    procedure IWAppFormCreate(Sender: TObject);
    procedure btSaveAsyncClick(Sender: TObject; EventParams: TStringList);
    procedure btLoadAsyncClick(Sender: TObject; EventParams: TStringList);
    procedure TIWHTML5LocalStorage1AsyncGetItems(Sender: TObject; EventParams,
      Items: TStringList);
    procedure btShowAllAsyncClick(Sender: TObject; EventParams: TStringList);
    procedure TIWHTML5LocalStorage1AsyncGetAllItems(Sender: TObject;
      EventParams, Items: TStringList);
    procedure btClearAsyncClick(Sender: TObject; EventParams: TStringList);
    procedure IWButton1AsyncClick(Sender: TObject; EventParams: TStringList);
    procedure TIWHTML5LocalStorage1AsyncHTML5Error(Sender: TObject;
      EventParams: TStringList; ErrorMessage: string);
  public
    procedure LoadData();
  end;

implementation

{$R *.dfm}


procedure TIWForm4.btClearAsyncClick(Sender: TObject; EventParams: TStringList);
begin
  TIWHTML5LocalStorage1.ClearItems;
  TIWHTML5LocalStorage1.GetAllItems;
end;

procedure TIWForm4.btLoadAsyncClick(Sender: TObject; EventParams: TStringList);
begin
  LoadData;
end;

procedure TIWForm4.btSaveAsyncClick(Sender: TObject; EventParams: TStringList);
begin
  TIWHTML5LocalStorage1.SetItem('Name', editName.Text);
  TIWHTML5LocalStorage1.SetItem('FirstName', editFirstName.Text);
  TIWHTML5LocalStorage1.SetItem('Street', editStreet.Text);
  TIWHTML5LocalStorage1.SetItem('City', editCity.Text);
  TIWHTML5LocalStorage1.SetItem('Zip', editZip.Text);
  TIWHTML5LocalStorage1.SetItem('Country', editCountry.Text);

  TIWHTML5LocalStorage1.GetAllItems;
end;

procedure TIWForm4.btShowAllAsyncClick(Sender: TObject;
  EventParams: TStringList);
begin
  TIWHTML5LocalStorage1.GetAllItems;
end;

procedure TIWForm4.IWAppFormCreate(Sender: TObject);
begin
  LoadData;
end;

procedure TIWForm4.IWButton1AsyncClick(Sender: TObject;
  EventParams: TStringList);
begin
  TIWHTML5LocalStorage1.RemoveItem('Name');
  TIWHTML5LocalStorage1.RemoveItem('FirstName');
  TIWHTML5LocalStorage1.RemoveItem('Street');
  TIWHTML5LocalStorage1.RemoveItem('City');
  TIWHTML5LocalStorage1.RemoveItem('Zip');
  TIWHTML5LocalStorage1.RemoveItem('Country');

  TIWHTML5LocalStorage1.GetAllItems;
end;

procedure TIWForm4.LoadData;
var
  items: TStringList;
begin
  items := TStringList.Create;
  try
    items.Add('Name');
    items.Add('FirstName');
    items.Add('Street');
    items.Add('City');
    items.Add('Zip');
    items.Add('Country');
    TIWHTML5LocalStorage1.GetItems(items);
  finally
    items.Free;
  end;

  TIWHTML5LocalStorage1.GetAllItems;
end;

procedure TIWForm4.TIWHTML5LocalStorage1AsyncGetAllItems(Sender: TObject;
  EventParams, Items: TStringList);
var
  I: integer;
begin
  IWListbox1.Clear;

  for I := 0 to Items.Count - 1 do
  begin
    IWListbox1.Items.Add(Items.Names[I] + ': ' + Items.ValueFromIndex[I]);
  end;    
end;

procedure TIWForm4.TIWHTML5LocalStorage1AsyncGetItems(Sender: TObject;
  EventParams, Items: TStringList);
var
  I: Integer;
begin
  for I := 0 to Items.Count - 1 do
  begin
    if Items.Names[I] = 'Name' then
      editName.Text := Items.ValueFromIndex[I];

    if Items.Names[I] = 'FirstName' then
      editFirstName.Text := Items.ValueFromIndex[I];

    if Items.Names[I] = 'Street' then
      editStreet.Text := Items.ValueFromIndex[I];

    if Items.Names[I] = 'City' then
      editCity.Text := Items.ValueFromIndex[I];

    if Items.Names[I] = 'Zip' then
      editZip.Text := Items.ValueFromIndex[I];

    if Items.Names[I] = 'Country' then
      editCountry.Text := Items.ValueFromIndex[I];
  end;

  TIWHTML5LocalStorage1.GetAllItems;
end;

procedure TIWForm4.TIWHTML5LocalStorage1AsyncHTML5Error(Sender: TObject;
  EventParams: TStringList; ErrorMessage: string);
begin
  WebApplication.ShowMessage('HTML5 error: ' + ErrorMessage);
end;

initialization
  TIWForm4.SetAsMainForm;

end.
